*Procedure QueryBar
*-----------------------------------------------------------------------
* Just a simple query bar to show progress.  This program runs much
* faster in Dos than in Windows. Let me know of any improvements you
* might feel could help this Program to run faster in a windows setting
* I am a Dos user but decided to throw in a few windows commands just
* to see the difference.  I took out the color for Windows to try and
* speed it up.... didn't seem to help much.
*-----------------------------------------------------------------------

Private nRecords, nCounter, cColor, nKey, cCursorSetting, cTalkSetting,;
        cEscapeSetting, cEndingText
        
cTalkSetting = Set('Talk')
Set Talk Off

* Set Escape off - use inkey instead
cEscapeSetting = Set('Escape')
Set Escape Off

******************* Open Up a Table Here ***********************

nRecords = Reccount()
nKey     = 0

If nRecords = 0
   Wait Window 'You Must Open A Table First!!'
   Return
Endif

If _Dos
   Define Window wnProgress From 1,1 To 12,59;
       Color Scheme 5;
       Title 'MakeShift Query Bar'
Else
   Define Window wnProgress From 1,1 To 14,90;
       Color N/W+;
       Title 'MakeShift Query Bar';
       Font 'FoxFont',10
Endif   

Move Window wnProgress Center
Activate Window wnProgress

nCounter = 1
@ 6,2 Say  '0%'+Space( 7 )+'20%'+Space( 7 )+;
          '40%'+Space( 7 )+'60%'+Space( 7 )+;
          '80%'+Space( 7 )+'100%' 

@ 7,2 Say Chr(218)+Replicate( Chr(196),9  )+Chr(194)+;
                   Replicate( Chr(196),9  )+Chr(194)+;
                   Replicate( Chr(196),9  )+Chr(194)+;
                   Replicate( Chr(196),9  )+Chr(194)+;
                   Replicate( Chr(196),10 )+Chr(191) 

@ 8,2 Say Chr(179)+Replicate( ' ',50 )+Chr(179)

@ 9,2 Say Chr(192)+Replicate( Chr(196),50 )+Chr(217)


cCursorSetting = Set('Cursor')
Set Cursor Off

cEndingText = 'Processing All Completed!!'   && Message to user

Go Top
Scan While !Eof()
    nKey = Inkey()
    If nKey = 27
       Wait Window 'Are You Sure You Wish To Cancel (Y/N) ??' To cKey
       If Upper( cKey ) == 'Y'
          cEndingText = 'Processing Canceled!!'
          Exit
       Endif
    Endif    
    
    @ 1,0 Say Padc( 'Processing: '+Alltrim( Str( nCounter ) )+' Of '+;
              AllTrim( Str( nRecords ) ),Wcols(),' ')
              
    @ 4,0 Say Padc( AllTrim( Str( (nCounter/nRecords)*100 ) )+'% Completed',Wcols(),' ')              

    If _Dos
       * Setup Barometer Bar Color:  Note This May Take away from processing
       * Time and could just as easily be done away with

       cColor = IIf( ((nCounter/nRecords)*100 ) > 80, 'R/Rb+',;
                IIf( ((nCounter/nRecords)*100 ) > 60, 'Rb/Rb+',;
                IIf( ((nCounter/nRecords)*100 ) > 40, 'Gr+/Rb+',;
                IIf( ((nCounter/nRecords)*100 ) > 20, 'BG+/Rb+',;
                'W/Rb+' ) ) ) )
            

       * Show The Progress - Based On a 50 Column Area
       @ 8,3 Say Replicate( Chr(219),((nCounter/nRecords)*100 )/2 ) Color &cColor
       
    Else
    
       @ 8,3 Fill To 8,Max( 3,((nCounter/nRecords)*100 )/1.9 ) Color 'N/N'
       
    Endif

    *----------------------------
    * Process All Data Here....
    *-----------------------------         
    
    nCounter = nCounter + 1
EndScan
Wait Window cEndingText TimeOut 2

* Restore Old Settings
Set Cursor &cCursorSetting
Set Talk   &cTalkSetting
Set Escape &cEscapeSetting
*-------------------------

Release Window wnProgress

Return